
private import std.cstream;

private import CalcLexer;
private import CalcParser;
private import CalcTreeWalker;

private import antlrrt.runtime;

alias antlrrt.runtime.asWString asWString;

alias asWStringT!(float) asWString;



int main(char[][] args) {
	try {
		CalcLexer lexer = new CalcLexer(din);
		lexer.setFilename(asWString("<stdin>"));
		CalcParser parser = new CalcParser(lexer);
		parser.setFilename(asWString("<stdin>"));
		// Parse the input expression
		parser.expr();
		CommonAST t = cast(CommonAST)parser.getAST();
		// Print the resulting tree out in LISP notation
		System.outp.println(t.toStringTree());
		CalcTreeWalker walker = new CalcTreeWalker();
		// Traverse the tree created by the parser
		float r = walker.expr(t);
		System.outp.println("value is " ~ asWString(r));
	}
	catch(TokenStreamException e) {
		System.err.println("exception: " ~ e.getMessage());
	}
	catch(RecognitionException e) {
		System.err.println("exception: " ~ e.getMessage());
	}
	
	return 0;
}



