
private import std.cstream;

private import CalcLexer;
private import CalcParser;
private import Support;

private import antlrrt.runtime;



int main()
{
	try {
		CalcLexer lexer = new CalcLexer(din);
		lexer.setFilename(asWString("<stdin>"));
		CalcParser parser = new CalcParser(lexer);
		parser.setFilename(asWString("<stdin>"));
		// Parse the input expression
		parser.expr();
		CalcAST t = cast(CalcAST)parser.getAST();

		// Print the resulting tree out in LISP notation
		System.outp.println(t.toStringTree());

		// XML serialize the tree, showing
		// different physical node class types
		Writer w = new StreamWriter(dout);
		t.xmlSerialize(w);
		w.write(asWString("\n"));
		dout.flush();

		// Compute value and return
		int r = t.value();
		System.outp.println("value is " ~ asWString(r));
	} catch(Exception e) {
		System.err.println(asWString("exception: " ~ e.toString()));
	}
	
	return 0;
}
