private import std.cstream;

private import CalcLexer;
private import CalcParser;
private import CalcTreeWalker;

private import antlrrt.runtime;


int main(char[][] args) {
	try {
		CalcLexer lexer = new CalcLexer(din);
		CalcParser parser = new CalcParser(lexer);
		// Parse the input expression
		parser.expr();
		CommonAST t = cast(CommonAST)parser.getAST();
		// Print the resulting tree out in LISP notation
		System.outp.println(t.toStringList());
		CalcTreeWalker walker = new CalcTreeWalker();
		// Traverse the tree created by the parser
		walker.expr(t);
		t = cast(CommonAST)walker.getAST();
		System.outp.println(t.toStringList());
	} catch(Exception e) {
		System.err.println(asWString("exception: " ~ e.toString()));
	}
	
	return 0;
}
